#include "cpsp/gecode/GC_StlSetRangeIterator.hh"

namespace cpsp
{
  namespace gecode
  {
  	
  	GC_StlSetRangeIterator::GC_StlSetRangeIterator() :
  		data(NULL), noFurtherRange(true)
  	{
  		getNextRange();
  	}
  		
	GC_StlSetRangeIterator::GC_StlSetRangeIterator(const std::set<int>* data_) :
		data(data_), noFurtherRange(false)
	{
		if (data != NULL) 
			actElem = data->begin();
		getNextRange();
	}
	
	GC_StlSetRangeIterator::~GC_StlSetRangeIterator()
	{
	}
	
	void
	GC_StlSetRangeIterator::getNextRange() {
		if (data==NULL || actElem == data->end()) {
			noFurtherRange = true;
			return;
		}
			// naechste range identifizieren
		nextMin = *actElem;
		nextMax = nextMin;
			// neuen range aufbauen, bis ende des sets erreicht oder 
			// luecke entdeckt
		while ( (++actElem != data->end()) && (*actElem == (nextMax+1))) {
			nextMax++;
		}
	}

  } //namespace gecode
} // namespace cpsp
