#include "cpsp/gecode/GC_ValNearCenter.hh"

#include <gecode/iter.hh>

namespace cpsp
{
  namespace gecode
  {


	const ell::LatticeFrame* GC_ValNearCenter::latFrame = NULL;

	int	
	GC_ValNearCenter::val(const Gecode::Space* home, Gecode::Int::IntView x) const
	{
		using namespace Gecode::Int;
		using namespace Gecode::Iter::Ranges;
		
		int retVal = x.min();
		
			// iterator initialisieren
		ToValues< ViewRanges< IntView > > it;
		ViewRanges< IntView >  r(x);
		it.init( r );

			// hilfsvariablen initialisieren		
		ell::IntPoint center = latFrame->getCenter();
		double actDist = DBL_MAX, minDist = actDist;
			// werte pruefen
		unsigned int c = 0;
		while ( it() ) {	// noch gueltig
			c++;
				// aktuelle kern-center distanz berechnen
			actDist = latFrame->getPoint(it.val()).distance(center);
				// pruefen ob neues minimum
			if (actDist < minDist) {
				minDist = actDist;
				retVal = it.val();
			}
				// iterator erhoehen
			++it;
		}
		assert(c == x.size());
		
		return retVal;
	}
	
	Gecode::ModEvent
	GC_ValNearCenter::tell(	Gecode::Space* home, unsigned int a, 
							Gecode::Int::IntView x, int n)
	{
		assert((a == 0) || (a == 1));
		return (a == 0) ? x.eq(home,n) : x.nq(home,n);
	}

  } //namespace gecode
} // namespace cpsp
